struct synch {
  int count;   
  sem_t m; // mutex
  sem_t b; // blocked
  int N;   // number of threads
};

void initsynch(struct synch *s, int n)
{
  int i;
  s->count = 0;
  sem_init(&s->m, 0, 1);
  sem_init(&s->b, 0, 0);
  s->N = n;
}

void my_synch(struct synch *s)
{
  int i;
  sem_wait(&s->m);
  if (++s->count < s->N) {
    sem_post(&s->m);
    sem_wait(&s->b);
  }
  else {
    for (i=0; i < s->N - 1; i++) 
      sem_post(&s->b);
    sem_post(&s->m);
  }
}

struct synch sp;

void *thread(void *arg)
{
  ...
  mysynch(&sp);
  ...
}
